## lem 1.0

=== DESCRIPTION ===
Package: lem
Title: Linear Effects Models
Version: 1.0
Author: Ewa Szczurek
Description: Methods for simulating and inferring linear effects models
Reference: Szczurek E, Beerenwinkel N, Linear effects models of
        signaling pathways from combinatorial perturbation data,
        Bioinformatics. 2016 Jun 15;32(12):i297-i305. doi:
        10.1093/bioinformatics/btw268.
Maintainer: Ewa Szczurek <szczurek@mimuw.edu.pl>
Depends: R (>= 3.0)
Imports: methods, stats, e1071
biocViews: Bioinformatics, GraphsAndNetworks, Pathways, SystemsBiology,
        NetworkInference
URL: http://www.bioconductor.org
License: GPL (>= 2)
Packaged: 2019-01-28 23:11:13 UTC; ewaszczurek
NeedsCompilation: no

## lem 2022-12

=== Makefile ===
# Attempt to ask git for a version (tag or hash) but fall back on LEMRELEASE.
# Note that opam builds from a tar ball so LEMRELEASE will be used in that case.
LEMRELEASE:=2022-12-10
LEMVERSION:=$(shell git describe --dirty --always 2>/dev/null || echo $(LEMRELEASE))

DDIR=lem-$(LEMVERSION)

# by default assume local install
INSTALL_DIR := $(realpath .)

#all: il.pdf build-main ilTheory.uo
all: bin/lem libs_phase_1

# we might want run the tests for all backends that are present

install:
	mkdir -p $(INSTALL_DIR)/bin
	rm -f $(INSTALL_DIR)/bin/lem
	cp src/main.native $(INSTALL_DIR)/bin/lem
	rm -rf $(INSTALL_DIR)/share/lem
	mkdir -p $(INSTALL_DIR)/share/lem/library
	cp library/*.lem $(INSTALL_DIR)/share/lem/library
	cp library/*_constants $(INSTALL_DIR)/share/lem/library
	$(MAKE) -C ocaml-lib install
	cp -R coq-lib $(INSTALL_DIR)/share/lem
	cp -R hol-lib $(INSTALL_DIR)/share/lem
#	cp -R html-lib $(INSTALL_DIR)/share/lem
	cp -R isabelle-lib $(INSTALL_DIR)/share/lem
#	cp -R tex-lib $(INSTALL_DIR)/share/lem

uninstall:
	rm -f $(INSTALL_DIR)/bin/lem
	rm -rf $(INSTALL_DIR)/share/lem
	$(MAKE) -C ocaml-lib uninstall

build-doc:
	$(MAKE) -C doc

do-tests:
	$(MAKE) -C tests

lem_dep.tex: lem_dep.ott
	ott -o lem_dep.tex -picky_multiple_parses true lem_dep.ott

lem_dep.pdf: lem_dep.tex
	pdflatex lem_dep.tex

# this runs Lem on the Lem library (library/*.lem), leaving the
# generated OCaml, Coq, HOL4, and Isabelle files to ocaml-libs,
# hol-libs, etc.
libs_phase_1: 
	$(MAKE) -C library
	$(MAKE) ocaml-libs


# this processes the Lem-generated library files for that target,
# together with any other hand-written files needed (eg the ocaml
# pset.ml), through the target.
libs_phase_2:
#	$(MAKE) ocaml-libs
	$(MAKE) tex-libs
	$(MAKE) hol-libs
	$(MAKE) coq-libs
	$(MAKE) isa-libs

hol-libs: 
#	$(MAKE) -C library hol-libs
	cd hol-lib; Holmake --qof -k
	$(MAKE) -C library hol-lib-tests

ocaml-libs:
#	$(MAKE) -C library ocaml-libs
	$(MAKE) -C ocaml-lib all
	$(MAKE) -C library ocaml-lib-tests

isa-libs: 
#	$(MAKE) -C library isa-libs
	isabelle build -d isabelle-lib -b LEM

coq-libs: 
#	$(MAKE) -C library coq-libs
	cd coq-lib; coqc -R . Lem coqharness.v
	cd coq-lib; coq_makefile -f coq_makefile.in > Makefile
	$(MAKE) -C coq-lib

tex-libs: 
#	$(MAKE) -C library tex-libs
	cd tex-lib; pdflatex lem-libs.tex
	cd tex-lib; pdflatex lem-libs.tex

# test-other: test-ppcmem test-cpp test-cppppc
# 
# test-ppc:
# 	# ppc model
# 	$(MAKE) -C ../../sem/WeakMemory/ppc-abstract-machine
# 	# pull ppc model into ppcmem directory
# 	# DON'T COMMIT
# 	$(MAKE) -C ../ppcmem/system model
# 
# test-axppc:
# 	# Sela model	
# 	$(MAKE) -C ../axppc
# 	# pull Sela model into ppcmem directory
# 	# DON'T COMMIT
# 	$(MAKE) -C ../ppcmem/system axmodel
# 
# test-arm:
# 	# ARM flowing model
# 	$(MAKE) -C ../arm/flowing-things
# 	# pull ARM model into ppcmem directory
# 	# DON'T COMMIT
# 	$(MAKE) -C ../ppcmem/system flowingmodel
# 
# test-ppcmem: test-ppc test-axppc test-arm
# 	# next 3 compile PPCMEM
# 	# Check makefile in ppcmem/system is set to "text"
# 	# DON'T commit
# 	$(MAKE) -C ../ppcmem/system clean
# 	$(MAKE) -C ../ppcmem/system depend_text
# 	$(MAKE) -C ../ppcmem/system text
# 
# test-cpp:
# 	# C++. Chat with Mark to fix
# 	$(MAKE) -C ../cpp/axiomatic/ntc deadlock
# 	# C++. Chat with Mark to fix HOL building and Mark/Susmit/Mike ML
# 	# building
# 	#$(MAKE) -C ../cpp/opsem
# 	#$(MAKE) -C ../cpp/axiomatic/ntc/proofs all
# 
# test-cppppc:
# 	$(MAKE) -C ../cppppc proof
# 	$(MAKE) -C ../cppppc/proof2 lem
# 
# 
# MACHINEFILES=\
# MachineDefUtils.lem \
# MachineDefFreshIds.lem \
# MachineDefValue.lem \
# MachineDefTypes.lem \
# MachineDefInstructionSemantics.lem \
# MachineDefStorageSubsystem.lem \
# MachineDefThreadSubsystem.lem \
# MachineDefSystem.lem
# 
# test-tex:  lem
# 	rm -rf tests/test-tex/*
# 	cp ../WeakMemory/ppc-abstract-machine/*.lem tests/test-tex
# 	cp tests/test-tex-inc-wrapper.tex tests/test-tex 
# 	chmod ugo-w tests/test-tex/*.lem
# 	cd tests/test-tex; ../../lem -hol -tex -ocaml -lib ../../library $(MACHINEFILES)
# 	cd tests/test-tex; TEXINPUTS=../../tex-lib:$(TEXINPUTS) latex alldoc.tex; dvips alldoc
# 	cd tests/test-tex; TEXINPUTS=../../tex-lib:$(TEXINPUTS) latex test-tex-inc-wrapper.tex; dvips test-tex-inc-wrapper
# 	#cd tests/test-tex; TEXINPUTS=../../tex-lib:$(TEXINPUTS) latex MachineDefUtils.tex; dvips MachineDefUtils
# 	#cd tests/test-tex; TEXINPUTS=../../tex-lib:$(TEXINPUTS) latex MachineDefFreshIds.tex; dvips MachineDefFreshIds
# 	#cd tests/test-tex; TEXINPUTS=../../tex-lib:$(TEXINPUTS) latex MachineDefValue.tex; dvips MachineDefValue
# 	#cd tests/test-tex; TEXINPUTS=../../tex-lib:$(TEXINPUTS) latex MachineDefTypes.tex; dvips MachineDefTypes
# 	#cd tests/test-tex; TEXINPUTS=../../tex-lib:$(TEXINPUTS) latex MachineDefInstructionSemantics.tex; dvips MachineDefInstructionSemantics
# 	#cd tests/test-tex; TEXINPUTS=../../tex-lib:$(TEXINPUTS) latex MachineDefStorageSubsystem.tex; dvips MachineDefStorageSubsystem
# 	#cd tests/test-tex; TEXINPUTS=../../tex-lib:$(TEXINPUTS) latex MachineDefThreadSubsystem.tex; dvips MachineDefThreadSubsystem
# 	#cd tests/test-tex; TEXINPUTS=../../tex-lib:$(TEXINPUTS) latex MachineDefSystem.tex; dvips MachineDefSystem
# 
# test-texg:
# 	g tests/test-tex/alldoc
# 	#g tests/test-tex/MachineDefStorageSubsystem
# 
# test-texw:
# 	cd tests/test-tex; TEXINPUTS=../../tex-lib:$(TEXINPUTS) latex test-tex-inc-wrapper.tex; dvips test-tex-inc-wrapper
# 
# 
# test-texgw:
# 	g tests/test-tex/test-tex-inc-wrapper

debug: version share_directory
	rm -f library/lib_cache
	$(MAKE) -C src debug
	ln -sf src/main.d.byte lem


build-lem: version share_directory
	$(MAKE) -C src all
	ln -sf src/main.native lem

build-lem-profile: version share_directory
	$(MAKE) -C src profile
	ln -sf src/main.p.native lem-profile


lem: build-lem

bin/lem: lem
	mkdir -p bin
	cd bin && ln -sf ../src/main.native lem

OCAML-LIB-NON_LGPL =      \
ocaml-lib/Makefile	  \
ocaml-lib/big_int_impl.ml \
ocaml-lib/big_int_impl.mli \
ocaml-lib/nat_big_num.ml  \
ocaml-lib/nat_big_num.mli \
ocaml-lib/nat_num.ml	  \
ocaml-lib/nat_num.mli	  \
ocaml-lib/vector.ml       \
ocaml-lib/vector.mli
#  not
# pmap.ml
# pmap.mli
# pset.ml
# pset.mli

apply_header:
	headache -h etc/header `ls src/*.ml`
	headache -h etc/header `ls src/*.mli`
	headache -h etc/header `ls src/*.mly`
	headache -h etc/header `ls src/*.mll`
	headache -c etc/head_config -h etc/header `ls language/*.lem`
	headache -c etc/head_config -h etc/header `ls tex-lib/*.sty`
	headache -c etc/head_config -h etc/header `ls coq-lib/*.v`
	headache -c etc/head_config -h etc/header `ls isabelle-lib/*.thy`
	headache -c etc/head_config -h etc/header `ls tex-lib/*.sty`
	headache -c etc/head_config -h etc/header $(OCAML-LIB-NONLGPL) 
	headache -c etc/head_config -h etc/header `ls library/coq/*.lem`
	headache -c etc/head_config -h etc/header `ls library/hol/*.lem`
	headache -c etc/head_config -h etc/header `ls library/isabelle/*.lem`
	headache -c etc/head_config -h etc/header `ls library/ocaml/*.lem`


#lem_unwrapped.tex: lem.ott
#	ott -tex_wrap false -o lem_unwrapped.tex lem.ott
#
#install_lem_unwrapped: lem_unwrapped.tex
#	cp lem_unwrapped.tex ../../ott/examples/ich/generated/lem_unwrapped.tex

#src/version.ml: 
version:
	echo "(* Generated file -- do not edit. *)" > src/version.ml
	echo 'let v="$(LEMVERSION)"' >> src/version.ml

share_directory:
	echo "(* Generated file -- do not edit. *)" > src/share_directory.ml
	echo let d=\"$(INSTALL_DIR)/share/lem\" >> src/share_directory.ml


distrib: src/ast.ml version
	rm -rf $(DDIR)
	rm -rf $(DDIR).tar.gz
	mkdir $(DDIR)
	mkdir $(DDIR)/src
	mkdir $(DDIR)/src/ulib
	cp src/*.ml $(DDIR)/src/
	chmod a+w $(DDIR)/src/ast.ml
	chmod a+w $(DDIR)/src/version.ml
	cp src/*.mli $(DDIR)/src/
	cp src/*.mll $(DDIR)/src/
	cp src/*.mly $(DDIR)/src/
	cp src/_tags $(DDIR)/src/
	cp src/ulib/*.ml $(DDIR)/src/ulib/
	cp src/ulib/*.mli $(DDIR)/src/ulib/
	mkdir $(DDIR)/library
	mkdir $(DDIR)/library/hol
	mkdir $(DDIR)/library/isabelle
	mkdir $(DDIR)/library/ocaml
	cp library/*.lem $(DDIR)/library/
	cp library/isabelle/constants $(DDIR)/library/isabelle/
	cp library/isabelle/*.lem $(DDIR)/library/isabelle/
	cp library/hol/constants $(DDIR)/library/hol/
	cp library/hol/*.lem $(DDIR)/library/hol/
	cp library/ocaml/*.lem $(DDIR)/library/ocaml/
	mkdir $(DDIR)/ocaml-lib
	cp ocaml-lib/*.ml $(DDIR)/ocaml-lib	
	cp ocaml-lib/*.mli $(DDIR)/ocaml-lib	
	cp ocaml-lib/*.mllib $(DDIR)/ocaml-lib	
	cp ocaml-lib/Makefile $(DDIR)/ocaml-lib	
	mkdir $(DDIR)/tex-lib
	cp tex-lib/lem.sty $(DDIR)/tex-lib
	cp Makefile-distrib $(DDIR)/Makefile
	cp src/Makefile-distrib $(DDIR)/src/Makefile
	cp README $(DDIR)
	cp LICENSE $(DDIR)
	headache -h header `ls $(DDIR)/src/*.ml`
	headache -h header `ls $(DDIR)/src/*.mli`
	headache -h header `ls $(DDIR)/src/*.mly`
	headache -h header `ls $(DDIR)/src/*.mll`
	headache -c head_config -h header `ls $(DDIR)/tex-lib/*.sty`
	headache -c head_config -h header `ls $(DDIR)/library/*.lem`
	headache -c head_config -h header `ls $(DDIR)/library/hol/*.lem`
	headache -c head_config -h header `ls $(DDIR)/library/isabelle/*.lem`
	headache -c head_config -h header `ls $(DDIR)/library/ocaml/*.lem`
	tar cf $(DDIR).tar $(DDIR)
	gzip $(DDIR).tar
	rm -rf $(DDIR)

clean:
	-$(MAKE) -C language clean
	-$(MAKE) -C src clean
	-$(MAKE) -C coq-lib clean
	-$(MAKE) -C ocaml-lib clean
	-$(MAKE) -C tex-lib clean
	-rm -f coq-lib/Makefile
	-rm -f coq-lib/coqharness.vo
	-rm -f coq-lib/coqharness.glob
	-rm -rf src/version.ml lem library/lib_cache src/share_directory.ml
	#-rm -rf lem_dep.tex lem_dep.pdf lem_dep.aux lem_dep.log

cleanall: clean
	-$(MAKE) -C doc clean
	-$(MAKE) -C slides clean
	-$(MAKE) -C manual cleanall
	-$(MAKE) -C ocaml-lib clean
	-$(MAKE) -C tests clean
	-rm -rf lem-$(LEMVERSION) lem-$(LEMVERSION).tar.gz

=== doc/Makefile ===


##  build all documentation and create links from this directory to it

all: 
# manual
	$(MAKE) -C manual
	ln -sf manual/lem-manual.html .
	ln -sf manual/lem-manual.pdf .
# lem Ott grammar
	$(MAKE) -C ../language
	ln -sf ../language/lem.pdf .
# library documentation
	$(MAKE) -C .. tex-libs
	ln -sf ../tex-lib/lem-libs.pdf .
	../lem -print_env ../library/pervasives.lem > lem-libs-pervasives.txt  
	../lem -print_env ../library/pervasives_extra.lem > lem-libs-pervasives-extra.txt
# source documentation
	$(MAKE) -C ../src .
	ln -sf ../src/html-doc .
	$(MAKE) -C ../src doc-pdf
	ln -sf ../src/tex-doc/lem-doc.pdf .
	$(MAKE) -C ../src doc-dot
	ln -sf ../src/dep.pdf  .


# pull lem-draft.pdf
pull-lem-draft:
	cp ~/rsem/lem/doc/pldi2014-submission/lem-icfp-2014.pdf  lem-draft.pdf 



## copy built documentation 

TARGET=built-doc
snapshot:
	cp -rL lem-manual.html $(TARGET)
	cp lem-manual.pdf $(TARGET)
	cp lem.pdf $(TARGET)
	cp lem-libs.pdf $(TARGET)
	cp lem-libs-pervasives.txt $(TARGET)
	cp lem-libs-pervasives-extra.txt $(TARGET)
	cp lem-doc.pdf $(TARGET)
	cp dep.pdf $(TARGET)
	cp lem-draft.pdf $(TARGET)

# not building?
#	cp -rL html-doc $(TARGET)

INSTALL_TARGET=~/public_html/lem
install:
	cp index.html $(INSTALL_TARGET)
	cp style.css $(INSTALL_TARGET)
	cp -r built-doc $(INSTALL_TARGET)

clean:
	rm -rf dep.pdf html-doc doc-dep.pdf doc.pdf lem.pdf lem-libs.pdf lem-manual.html lem-manual.pdf lem-doc.pdf
	rm -rf lem-libs-pervasives-extra.txt
	rm -rf lem-libs-pervasives.txt

cleansnapshot:
	rm -rf built-doc/*

=== language/Makefile ===
#OTTLIB=/Users/sowens/ott/hol
OTTLIB=$(dir $(shell which ott))../hol

all: lem.pdf

lem.pdf: lem.tex
	pdflatex lem.tex

lemTheory.uo: lemScript.sml
	Holmake --qof -I $(OTTLIB) lemTheory.uo

lem.tex ../src/ast.ml lemScript.sml: lem.ott
	rm -f ../src/ast.ml
	ott  -ocaml_include_terminals true -o lem.tex -o ../src/ast.ml -o lemScript.sml -picky_multiple_parses true lem.ott
	chmod a-w ../src/ast.ml

# for ascii grammar
foo:
	ott  -alltt out.tex -showraw true -picky_multiple_parses true lem.ott


lem-inc.tex: lem.hacked.ott Makefile
	ott  -ocaml_include_terminals true -o lem-inc.pre.tex -tex_wrap false -picky_multiple_parses true lem.hacked.ott
	sed 's/\\_aux//g' lem-inc.pre.tex > lem-inc.tex

lem.hacked.ott: lem.ott Makefile
	grep -v NOPLDI lem.ott | sed 's/%PLDIlHACK/{{ tex }}/g' | sed 's/\^{l}//g' > lem.hacked.ott

lem.lem: lem.ott
	ott -o lem.lem -picky_multiple_parses true lem.ott


clean:
	rm -rf *~
	-rm -rf *.uo *.ui lemTheory.sig lemTheory.sml lem.tex lemScript.sml lem.aux lem.log lem.dvi lem.ps lem_unwrapped.tex .HOLMK lem-inc.tex lem.hacked.ott
#lem.sys lem library/lib_cache

=== src/Makefile ===
all:
	ocamlbuild -use-ocamlfind -cflags -g main.native
#	ocamlbuild main.native

profile:
	ocamlbuild -cflags -g main.p.native

doc:
	mkdir -p html-doc
	ocamlfind ocamldoc -package zarith -I _build/ -I _build/ulib/ *.mli finite_map.ml -sort -html -d html-doc

doc-pdf:
	mkdir -p tex-doc
	ocamlfind ocamldoc -package zarith -I _build/ -I _build/ulib/ *.mli finite_map.ml -latex -sort -d tex-doc -o tex-doc/lem-doc.tex; true
	cd tex-doc; pdflatex lem-doc.tex

doc-dot:
	ocamlfind ocamldoc -package zarith -I _build/ -I _build/ulib/ *.ml *.mli ulib/*.mli ulib/*.ml -dot -sort -d tex-doc -dot-reduce -o dep.dot; true
	dot -Tpdf -o dep.pdf dep.dot

debug: 
	ocamlbuild -tag annot main.d.byte

clean:
	-ocamlbuild -clean
	-rm -rf main.native
	-rm -rf _build
	-rm -rf html-doc
	-rm -rf tex-doc

=== examples/ocaml_light/Makefile ===
all:

DIR=~/rsem/ott/examples/caml
getmodel:
	make -C $(DIR) lemtest
	cp $(DIR)/caml_typedef.lem           .
	cp $(DIR)/caml_typedef_reduction.ott .
	cp $(DIR)/caml_typedef_syntax.ott    .
	cp $(DIR)/caml_typedef_typing.ott    .

=== tests/backends/Makefile ===
poly_lib = $(dir $(shell which poly))../lib/

all: lem holtests ocamltests 

lem:
	$(MAKE) -C ../..

holtests: TypesTheory.uo PatsTheory.uo ExpsTheory.uo HoltestTheory.uo

coqtests: types.vo pats.vo exps.vo 

ocamltests: types.byte pats.byte exps.byte classes.byte

isabelletests: isatests/Pats.thy isatests/Types.thy isatests/Exps.thy
	isabelle make clean
	isabelle make isatests

%.ml: %.lem ../../lem
	../../lem -wl ign -ocaml $<

TypesScript.sml: types.lem ../../lem
	../../lem -wl ign -hol $<

PatsScript.sml: pats.lem ../../lem
	../../lem -wl ign -hol $<

ExpsScript.sml: exps.lem ../../lem
	../../lem -wl ign -hol $<

HoltestScript.sml: holtest.lem ../../lem
	../../lem -wl ign -hol $<

%.v: %.lem ../../lem
	../../lem -wl ign -coq $<

Types.thy: types.lem ../../lem
	../../lem -wl ign -isa $<

Pats.thy: pats.lem ../../lem
	../../lem -wl ign -isa $<

Exps.thy: exps.lem ../../lem
	../../lem -wl ign -isa $<

%Theory.uo: %Script.sml hol_preload
	Holmake --poly ./hol_preload --qof --quiet $@

%.vo: %.v
	coqc $<

extract.cma:
	$(MAKE) -C ../../ocaml-lib

%.byte: %.ml $(CURDIR)/../../ocaml-lib/_build/extract.cma
	ocamlc.opt -I $(CURDIR)/../../ocaml-lib/_build -o $@ extract.cma $<

HolDoc.uo HolDoc.ui: HolDoc.sml HolDoc.sig
	Holmake HolDoc.uo

hol_preload.o: HolDoc.uo HolDoc.ui hol_preload.ml
	hol.builder < hol_preload.ml

hol_preload: hol_preload.o
	gcc -L$(poly_lib) -o hol_preload -lpolymain -lpolyml -segprot POLY rwx rwx hol_preload.o

isatests/%.thy: %.thy
	cp $< $@

clean:
	-Holmake cleanAll
	-isabelle make clean
	-rm -fr hol_preload *.cmi *.cmo *.byte pats.ml *.uo *.ui *.v *.thy *Theory.* *Script.* *.imn hol_preload.o exps.ml classes.ml types.ml _build isatests/*.thy holtest.ml

.precious: PatsScript.sml pats.ml ExpsScript.sml exps.ml classes.ml TypesScript.sml types.ml types.v Exps.thy exps.v Pats.thy Types.thy types.v HolScript.sml

## lem 2022-12-10+dfsg2

=== debian/changelog ===
lem (2022-12-10+dfsg2-4build1) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 Jan 2025 10:56:19 +0100

lem (2022-12-10+dfsg2-4) unstable; urgency=medium

  * Team upload
  * Fix build on bytecode architectures (Closes: #1084815)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 14 Oct 2024 11:25:29 +0200

lem (2022-12-10+dfsg2-3) unstable; urgency=medium

  * Update liblem-ocaml-dev.install.in

 -- Bo YU <tsu.yubo@gmail.com>  Mon, 23 Sep 2024 14:56:56 +0800

lem (2022-12-10+dfsg2-2) unstable; urgency=medium

  * Update batUChar.* and batUTF8.* license.
  * Remove unused license paragraph on lgpl-2.

 -- Bo YU <tsu.yubo@gmail.com>  Tue, 17 Sep 2024 14:24:42 +0800

lem (2022-12-10+dfsg2-1) unstable; urgency=low

  * Initial release. (Closes: #1065658)

 -- Bo YU <tsu.yubo@gmail.com>  Sun, 23 Jun 2024 07:39:43 +0800

=== debian/control ===
Source: lem
Priority: optional
Section: ocaml
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Bo YU <tsu.yubo@gmail.com>
Build-Depends: debhelper-compat (= 13),
 ocaml,
 ocaml-dune (>= 2.2.0),
 dh-ocaml (>= 1.2),
 libzarith-ocaml-dev,
 libnum-ocaml-dev,
 ocaml-findlib,
 ocamlbuild,
 help2man,
Standards-Version: 4.7.0
Homepage: https://github.com/rems-project/lem
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/ocaml-team/lem.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/lem

Package: lem
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${ocaml:Depends}
Provides:
 ${ocaml:Provides}
Suggests:
 ocaml-findlib
Description: Tool merging math and logic for executable definitions (tool)
 Lem is a tool for lightweight executable mathematics, for writing,
 managing, and publishing large-scale portable semantic definitions,
 with export to LaTeX, executable code (currently OCaml) and
 interactive theorem provers (currently Coq, HOL4, and Isabelle/HOL).
 .
 It is also intended as an intermediate language for generating
 definitions from domain-specific tools, and for porting definitions
 between interactive theorem proving systems.
 .

Package: liblem-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
 libnum-ocaml-dev,
 libstdlib-ocaml-dev,
 libzarith-ocaml-dev,
Provides: ${ocaml:Provides}
Suggests:
 ocaml-findlib
Description: Tool merging math and logic for executable definitions (development)
 Lem is a tool for lightweight executable mathematics, for writing,
 managing, and publishing large-scale portable semantic definitions,
 with export to LaTeX, executable code (currently OCaml) and
 interactive theorem provers (currently Coq, HOL4, and Isabelle/HOL).
 .
 It is also intended as an intermediate language for generating
 definitions from domain-specific tools, and for porting definitions
 between interactive theorem proving systems.
 .
 This package contains the development files.

## lem 2025-03

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Attempt to ask git for a version (tag or hash) but fall back on LEMRELEASE.
 # Note that opam builds from a tar ball so LEMRELEASE will be used in that case.
-LEMRELEASE:=2022-12-10
+LEMRELEASE:=2025-03-13
 LEMVERSION:=$(shell git describe --dirty --always 2>/dev/null || echo $(LEMRELEASE))
 
 DDIR=lem-$(LEMVERSION)
@@ -14,23 +14,23 @@
 # we might want run the tests for all backends that are present
 
 install:
-	mkdir -p $(INSTALL_DIR)/bin
-	rm -f $(INSTALL_DIR)/bin/lem
-	cp src/main.native $(INSTALL_DIR)/bin/lem
-	rm -rf $(INSTALL_DIR)/share/lem
-	mkdir -p $(INSTALL_DIR)/share/lem/library
-	cp library/*.lem $(INSTALL_DIR)/share/lem/library
-	cp library/*_constants $(INSTALL_DIR)/share/lem/library
+	mkdir -p "$(INSTALL_DIR)/bin"
+	rm -f "$(INSTALL_DIR)/bin/lem"
+	cp src/main.native "$(INSTALL_DIR)/bin/lem"
+	rm -rf "$(INSTALL_DIR)/share/lem"
+	mkdir -p "$(INSTALL_DIR)/share/lem/library"
+	cp library/*.lem "$(INSTALL_DIR)/share/lem/library"
+	cp library/*_constants "$(INSTALL_DIR)/share/lem/library"
 	$(MAKE) -C ocaml-lib install
-	cp -R coq-lib $(INSTALL_DIR)/share/lem
-	cp -R hol-lib $(INSTALL_DIR)/share/lem
-#	cp -R html-lib $(INSTALL_DIR)/share/lem
-	cp -R isabelle-lib $(INSTALL_DIR)/share/lem
-#	cp -R tex-lib $(INSTALL_DIR)/share/lem
+	cp -R coq-lib "$(INSTALL_DIR)/share/lem"
+	cp -R hol-lib "$(INSTALL_DIR)/share/lem"
+#	cp -R html-lib "$(INSTALL_DIR)/share/lem"
+	cp -R isabelle-lib "$(INSTALL_DIR)/share/lem"
+#	cp -R tex-lib "$(INSTALL_DIR)/share/lem"
 
 uninstall:
-	rm -f $(INSTALL_DIR)/bin/lem
-	rm -rf $(INSTALL_DIR)/share/lem
+	rm -f "$(INSTALL_DIR)/bin/lem"
+	rm -rf "$(INSTALL_DIR)/share/lem"
 	$(MAKE) -C ocaml-lib uninstall
 
 build-doc:
@@ -186,6 +186,7 @@
 
 
 lem: build-lem
+	true
 
 bin/lem: lem
 	mkdir -p bin

=== library/Makefile ===
LIBS=bool.lem basic_classes.lem function.lem maybe.lem num.lem tuple.lem list.lem either.lem set_helpers.lem set.lem map.lem relation.lem sorting.lem function_extra.lem assert_extra.lem list_extra.lem string.lem num_extra.lem map_extra.lem set_extra.lem maybe_extra.lem string_extra.lem word.lem show.lem show_extra.lem machine_word.lem pervasives.lem pervasives_extra.lem debug.lem

NOW:=$(shell date +%Y-%m-%d---%H-%M-%S)
OCAML_BUILD_DIR=ocaml-build-dir---${NOW}
HOL_BUILD_DIR=hol-build-dir---${NOW}
ISA_BUILD_DIR=isa-build-dir---${NOW}

OCAML_BUILD_DIR_REUSED=ocaml-build-dir-reused
HOL_BUILD_DIR_REUSED=hol-build-dir-reused
ISA_BUILD_DIR_REUSED=isa-build-dir-reused


markdown_targets := $(patsubst %.markdown,%.html,$(wildcard *.markdown))

libs : ocaml-libs hol-libs isa-libs coq-libs tex-libs html-libs

.PHONY: ../lem
../lem:
	$(MAKE) -C .. build-lem

hol-libs: ../lem
	../lem -hol -hol_remove_matches -outdir ../hol-lib -wl ign -wl_auto_import err -wl_rename err ${LIBS} -auxiliary_level none -only_changed_output

ocaml-libs: ../lem
	../lem -ocaml -outdir ../ocaml-lib -wl ign -wl_auto_import err -wl_rename err ${LIBS} -auxiliary_level none -only_changed_output

isa-libs: ../lem
	../lem -isa -outdir ../isabelle-lib -wl ign -wl_auto_import err -wl_rename err ${LIBS} -auxiliary_level none -only_changed_output

coq-libs: ../lem
	../lem -coq -outdir ../coq-lib -wl ign -wl_auto_import err ${LIBS} -auxiliary_level none -only_changed_output

tex-libs: ../lem
	../lem -tex_all ../tex-lib/lem-libs.tex -wl ign -wl_auto_import err ${LIBS} 

html-libs: ../lem
	../lem -html -outdir ../html-lib -wl ign -wl_auto_import err ${LIBS} 

ocaml-lib-tests: 
	@mkdir -p ${OCAML_BUILD_DIR}
	@rm -rf ocaml-build-dir
	@ln -s ${OCAML_BUILD_DIR} ocaml-build-dir
	@../lem -ocaml -outdir ${OCAML_BUILD_DIR} -wl ign -wl_auto_import err -wl_rename err ${LIBS} -only_auxiliary -only_changed_output -no_dep_reorder
	@./run-ocaml-tests.sh ${OCAML_BUILD_DIR}

ocaml-lib-tests-reuse: 
	@mkdir -p ${OCAML_BUILD_DIR_REUSED} || true
	@../lem -ocaml -outdir ${OCAML_BUILD_DIR_REUSED} -wl ign -wl_auto_import err -wl_rename err ${LIBS} -only_auxiliary -only_changed_output -no_dep_reorder
	@./run-ocaml-tests.sh ${OCAML_BUILD_DIR_REUSED}

hol-lib-tests: 
	@mkdir -p ${HOL_BUILD_DIR}
	@rm -f hol-build-dir
	@ln -s ${HOL_BUILD_DIR} hol-build-dir       
	@../lem -hol -outdir ${HOL_BUILD_DIR} -wl ign -wl_auto_import err -wl_rename err ${LIBS} -only_auxiliary -auxiliary_level auto -only_changed_output -no_dep_reorder
	@cp Holmakefile ${HOL_BUILD_DIR}
	@cd ${HOL_BUILD_DIR}; Holmake 

hol-lib-tests-reuse: 
	@mkdir -p ${HOL_BUILD_DIR_REUSED} || true
	@../lem -hol -outdir ${HOL_BUILD_DIR_REUSED} -wl ign -wl_auto_import err -wl_rename err ${LIBS} -only_auxiliary -auxiliary_level auto -only_changed_output -no_dep_reorder
	@cp Holmakefile ${HOL_BUILD_DIR_REUSED}
	@cd ${HOL_BUILD_DIR_REUSED}; Holmake 

# The tests are generated from the same files as the library, but are run in a
# separate Isabelle session, so we manually patch up the names with sed.
isa-lib-tests: 
	@mkdir -p ${ISA_BUILD_DIR}
	@rm -f isa-build-dir
	@ln -s ${ISA_BUILD_DIR} isa-build-dir       
	@../lem -isa -outdir ${ISA_BUILD_DIR} -wl ign -wl_auto_import err -wl_rename err ${LIBS} -only_auxiliary -auxiliary_level auto -only_changed_output -no_dep_reorder
	@sed -i -e 's/^  "Lem_/  "LEM.Lem_/' -e 's/^  "Lem"/  "LEM.Lem"/' ${ISA_BUILD_DIR}/Lem_*Auxiliary.thy
	@./gen-isa-tests.sh ${ISA_BUILD_DIR} 
	@echo "please run\n   isabelle jedit -d ../isabelle-lib -l LEM ${ISA_BUILD_DIR}/LemTests.thy"

isa-lib-tests-reuse: 
	@mkdir -p ${ISA_BUILD_DIR_REUSED} || true
	@../lem -isa -outdir ${ISA_BUILD_DIR_REUSED} -wl ign -wl_auto_import err -wl_rename err ${LIBS} -only_auxiliary -auxiliary_level auto -only_changed_output -no_dep_reorder
	@sed -i -e 's/^  "Lem_/  "LEM.Lem_/' -e 's/^  "Lem"/  "LEM.Lem"/' ${ISA_BUILD_DIR}/Lem_*Auxiliary.thy
	@./gen-isa-tests.sh ${ISA_BUILD_DIR_REUSED} 
	@echo "please run\n   isabelle jedit ${ISA_BUILD_DIR_REUSED}/LemTests.thy"


markdown: $(markdown_targets)

%.html : %.markdown
	markdown $< > $@

clean:
	rm -rf ocaml-build-dir*
	rm -rf hol-build-dir*
	rm -rf isa-build-dir*

=== ocaml-lib/Makefile ===
USE_OCAMLBUILD ?= true

ifeq "$(USE_OCAMLBUILD)" "false"
  include no_ocamlbuild.mk
else
  include ocamlbuild.mk
endif

clean:
	$(MAKE) -f ocamlbuild.mk clean
	$(MAKE) -f no_ocamlbuild.mk clean

=== src/Makefile ===
--- 
+++ 
@@ -1,4 +1,9 @@
+# Remove the symlink if it exists before building, as opam builds on
+# Windows with native symlinks appear to clobber an existing
+# executable otherwise.
+
 all:
+	rm -f main.native
 	ocamlbuild -use-ocamlfind -cflags -g main.native
 #	ocamlbuild main.native

=== tests/Makefile ===
all:
	$(MAKE) -C ident_backend
	$(MAKE) -C type_errors
	$(MAKE) -C backends

clean:
	-$(MAKE) -C ident_backend clean
	-$(MAKE) -C type_errors clean
	-$(MAKE) -C backends clean

=== tex-lib/Makefile ===
all:
	$(MAKE) -C .. tex-libs

clean:
	rm -f *.toc *.aux *.ps *.log *.lof *.bbl *.blg *.hix *.tid *.tde *.out *~

=== doc/manual/Makefile ===
INPUT_FILES := \
  header.md \
  introduction.md \
  installation.md \
  invocation.md \
  backends.md \
    backend_ocaml.md \
    backend_hol.md \
    backend_isa.md \
    backend_coq.md \
    backend_tex.md \
    backend_html.md \
  library.md \
  own_lem_files.md \
  language.md \
  backend_linking.md \
  typeclasses.md \
  refactoring.md \


all: lem-manual.html lem-manual.pdf

clean:
	rm -f lem-manual.md lem-manual.html  lem-manual.pdf

lem-manual.md : $(INPUT_FILES)
	cat $(INPUT_FILES) > lem-manual.md

lem-manual.html : lem-manual.md
	pandoc -s --number-sections --toc lem-manual.md -o lem-manual.html

lem-manual.pdf : lem-manual.md my-pandoc-latex-template.latex
	pandoc  --template my-pandoc-latex-template.latex -s --number-sections --toc lem-manual.md -o lem-manual.tex
	pdflatex lem-manual.tex && pdflatex lem-manual.tex && pdflatex lem-manual.tex




#lem-language.pdf: 
#	$(MAKE) -C ../language && cp ../language/lem-language.pdf .

=== ocaml-lib/num_impl_num/Makefile ===
clean:
	\rm -f *.c* *.o *.cma *.cmxa *.a

=== tests/ident_backend/Makefile ===
all:
	ocamlbuild -lib str add_comments.byte
	$(MAKE) -C ../..
	./test_script basic_type.lem
	./test_script basic_exprs.lem
	./test_script basic_pats.lem
	./test_script basic_defs.lem
	./test_script basic_typedefs.lem
	./test_script identifiers.lem
	./test_script classes.lem
	./test_script do_notation.lem

clean:
	-ocamlbuild -clean
	-rm -f test.lem

=== tests/type_errors/Makefile ===
all:
	$(MAKE) -C ../..
	rm -f results
	ocamlbuild -lib unix -lib str tester.byte
	./tester.byte < tests
	chmod a-w results
	diff results results_checked

clean:
	-ocamlbuild -clean
	-rm -f results test.lem testScript.sml

=== tests/backends/textests/Makefile ===
all: Out10.pdf

Out10.pdf: out10.lem
	lem -wl_unused_vars ign -tex out10.lem && \
   TEXINPUTS=~/bitbucket/lem/tex-lib/:.:  pdflatex Out10.tex

clean:
	rm -rf *~
	rm -rf    \
Out10.aux         \
Out10-inc.tex	  \
Out10.log	  \
Out10.pdf	  \
Out10.tex         \
Out10-use_inc.tex

## lem 2025-03-13+dfsg

=== debian/changelog ===
lem (2025-03-13+dfsg-1build1) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 30 Aug 2025 09:38:21 +0200

lem (2025-03-13+dfsg-1) unstable; urgency=medium

  * New upstream version 2025-03-13+dfsg. (Closes: #1105410)
  * Rebase debian/patches/
  * Bump Standards-Version to 4.7.2 (no changes)
  * Update year of d/copyright
  * Update my Debian email

 -- Bo YU <vimer@debian.org>  Tue, 27 May 2025 19:03:45 +0800

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk
include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM
export OCAMLBUILD_BEST

MAN_NAME_SECTION="Tool merging math and logic for executable definitions"

%:
	dh $@ --with ocaml

override_dh_auto_build:
	$(MAKE)

# Some files generated from the lem library, so they don't have .mli files and
# if for documentation purposes it's better to refer to the .lem source files.
# The $(cp) will copy these files which already available .mli file, but this should
# be harmless. See README.Debian and https://github.com/rems-project/lem/issues/34
execute_after_dh_auto_install:
	cp $(CURDIR)/ocaml-lib/_build_num/*.ml $(CURDIR)/debian/tmp/lem_num/
	cp $(CURDIR)/ocaml-lib/_build_zarith/*.ml $(CURDIR)/debian/tmp/lem_zarith/
	help2man $(CURDIR)/debian/tmp/bin/lem --name=$(MAN_NAME_SECTION) --version-string=$(DEB_VERSION_UPSTREAM) > debian/lem.1

override_dh_auto_clean:
	rm -rf bin/lem
	rm -rf lem
	rm -rf src/main.native
	rm -rf src/_build
	rm -rf src/version.ml
	rm -rf src/share_directory.ml
	rm -rf coq-lib/lem_*.v
	rm -rf library/ocaml-build-dir*
	rm -rf ocaml-lib/lem_*.ml
	rm -rf ocaml-lib/_build_num
	rm -rf ocaml-lib/_build_zarith
	rm -rf hol-lib/lemTheory.sml
	rm -rf hol-lib/lem_*.sml
	rm -rf html-lib/*.html
	rm -rf isabelle-lib/Lem_*.thy
	rm -rf tex-lib/lem-libs*.tex
	dh_clean

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg.*$//,repacksuffix=+dfsg,compression=xz \
https://github.com/rems-project/lem/tags .*/archive/.*/(\d\S+)\.tar\.gz
